/*
	Copyright (c) 2004-2011, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["epages.widget.Calendar"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.widget.Calendar"] = true;
dojo.provide("epages.widget.Calendar");
dojo.require("epages.widget");
dojo.require('dijit.Calendar');
dojo.require('epages.lang.date');
dojo.require('epages.widget.Tooltip');
dojo.require('epages.io.translation');

dojo.declare("epages.widget.Calendar", [dijit.Calendar], {
		/**
		 * public properties
		 */
		firstAvailableDate : null,
		lastAvailableDate  : null,

		/**
		 * private properties
		 */
		templateType       : "default",
		defaultTemplateType: "default", // read-only!
		templateString:"<table cellspacing=\"0\" cellpadding=\"0\" class=\"dijitCalendarContainer\" role=\"grid\" dojoAttachEvent=\"onkeypress: _onKeyPress\">\n\t<thead>\n\t\t<tr class=\"dijitReset dijitCalendarMonthContainer\" valign=\"top\">\n\t\t\t<th class='dijitReset' dojoAttachPoint=\"decrementMonth\">\n\t\t\t\t<img src=\"${_blankGif}\" alt=\"\" class=\"dijitCalendarIncrementControl dijitCalendarDecrease\" waiRole=\"presentation\">\n\t\t\t\t<span dojoAttachPoint=\"decreaseArrowNode\" class=\"dijitA11ySideArrow\">-</span>\n\t\t\t</th>\n\t\t\t<th class='dijitReset' colspan=\"5\">\n\t\t\t\t<div class=\"dijitVisible\">\n\t\t\t\t\t<div class=\"dijitPopup dijitMenu dijitMenuPassive dijitHidden\" dojoAttachPoint=\"monthDropDown\" dojoAttachEvent=\"onmouseup: _onMonthSelect, onmouseover: _onMenuHover, onmouseout: _onMenuHover\">\n\t\t\t\t\t\t<div class=\"dijitCalendarMonthLabelTemplate dijitCalendarMonthLabel\"></div>\n\t\t\t\t\t</div>\n\t\t\t\t</div>\n\t\t\t\t<div dojoAttachPoint=\"monthLabelSpacer\" class=\"dijitSpacer\"></div>\n\t\t\t\t<div dojoAttachPoint=\"monthLabelNode\" class=\"dijitCalendarMonthLabel dijitInline dijitVisible\" dojoAttachEvent=\"onmousedown: _onMonthToggle\"></div>\n\t\t\t</th>\n\t\t\t<th class='dijitReset' dojoAttachPoint=\"incrementMonth\">\n\t\t\t\t<img src=\"${_blankGif}\" alt=\"\" class=\"dijitCalendarIncrementControl dijitCalendarIncrease\" waiRole=\"presentation\">\n\t\t\t\t<span dojoAttachPoint=\"increaseArrowNode\" class=\"dijitA11ySideArrow\">+</span>\n\t\t\t</th>\n\t\t</tr>\n\t\t<tr>\n\t\t\t<th class=\"dijitReset dijitCalendarDayLabelTemplate\" role=\"columnheader\"><span class=\"dijitCalendarDayLabel\"></span></th>\n\t\t</tr>\n\t</thead>\n\t<tbody dojoAttachEvent=\"onclick: _onDayClick, onmouseover: _onDayMouseOver, onmouseout: _onDayMouseOut\" class=\"dijitReset dijitCalendarBodyContainer\">\n\t\t<tr class=\"dijitReset dijitCalendarWeekTemplate\" role=\"row\">\n\t\t\t<td class=\"dijitReset dijitCalendarDateTemplate\" role=\"gridcell\"><span class=\"dijitCalendarDateLabel\"></span></td>\n\t\t</tr>\n\t</tbody>\n\t<tfoot class=\"dijitReset dijitCalendarYearContainer\">\n\t\t<tr>\n\t\t\t<td class='dijitReset' valign=\"top\" colspan=\"7\">\n\t\t\t\t<h3 class=\"dijitCalendarYearLabel\">\n\t\t\t\t\t<span dojoAttachPoint=\"previousYearLabelNode\" class=\"dijitInline dijitCalendarPreviousYear\"></span>\n\t\t\t\t\t<span dojoAttachPoint=\"currentYearLabelNode\" class=\"dijitInline dijitCalendarSelectedYear\"></span>\n\t\t\t\t\t<span dojoAttachPoint=\"nextYearLabelNode\" class=\"dijitInline dijitCalendarNextYear\"></span>\n\t\t\t\t</h3>\n\t\t\t\t<div class=\"HideElement\" dojoType=\"dijit.form.DropDownButton\" dojoAttachPoint=\"monthDropDownButton\" id=\"${id}_mddb\" tabIndex=\"-1\"></div>\n\t\t\t</td>\n\t\t</tr>\n\t</tfoot>\n</table>\n", // need template for weeknumber
		_templateDirectory : dojo.moduleUrl("epages.widget", "templates"),
		widgetsInTemplate : true,
		_templateMapping : {
			'default' : {templateString:"<table cellspacing=\"0\" cellpadding=\"0\" class=\"dijitCalendarContainer\" role=\"grid\" dojoAttachEvent=\"onkeypress: _onKeyPress\">\n\t<thead>\n\t\t<tr class=\"dijitReset dijitCalendarMonthContainer\" valign=\"top\">\n\t\t\t<th class='dijitReset' dojoAttachPoint=\"decrementMonth\">\n\t\t\t\t<img src=\"${_blankGif}\" alt=\"\" class=\"dijitCalendarIncrementControl dijitCalendarDecrease\" waiRole=\"presentation\">\n\t\t\t\t<span dojoAttachPoint=\"decreaseArrowNode\" class=\"dijitA11ySideArrow\">-</span>\n\t\t\t</th>\n\t\t\t<th class='dijitReset' colspan=\"5\">\n\t\t\t\t<div class=\"dijitVisible\">\n\t\t\t\t\t<div class=\"dijitPopup dijitMenu dijitMenuPassive dijitHidden\" dojoAttachPoint=\"monthDropDown\" dojoAttachEvent=\"onmouseup: _onMonthSelect, onmouseover: _onMenuHover, onmouseout: _onMenuHover\">\n\t\t\t\t\t\t<div class=\"dijitCalendarMonthLabelTemplate dijitCalendarMonthLabel\"></div>\n\t\t\t\t\t</div>\n\t\t\t\t</div>\n\t\t\t\t<div dojoAttachPoint=\"monthLabelSpacer\" class=\"dijitSpacer\"></div>\n\t\t\t\t<div dojoAttachPoint=\"monthLabelNode\" class=\"dijitCalendarMonthLabel dijitInline dijitVisible\" dojoAttachEvent=\"onmousedown: _onMonthToggle\"></div>\n\t\t\t</th>\n\t\t\t<th class='dijitReset' dojoAttachPoint=\"incrementMonth\">\n\t\t\t\t<img src=\"${_blankGif}\" alt=\"\" class=\"dijitCalendarIncrementControl dijitCalendarIncrease\" waiRole=\"presentation\">\n\t\t\t\t<span dojoAttachPoint=\"increaseArrowNode\" class=\"dijitA11ySideArrow\">+</span>\n\t\t\t</th>\n\t\t</tr>\n\t\t<tr>\n\t\t\t<th class=\"dijitReset dijitCalendarDayLabelTemplate\" role=\"columnheader\"><span class=\"dijitCalendarDayLabel\"></span></th>\n\t\t</tr>\n\t</thead>\n\t<tbody dojoAttachEvent=\"onclick: _onDayClick, onmouseover: _onDayMouseOver, onmouseout: _onDayMouseOut\" class=\"dijitReset dijitCalendarBodyContainer\">\n\t\t<tr class=\"dijitReset dijitCalendarWeekTemplate\" role=\"row\">\n\t\t\t<td class=\"dijitReset dijitCalendarDateTemplate\" role=\"gridcell\"><span class=\"dijitCalendarDateLabel\"></span></td>\n\t\t</tr>\n\t</tbody>\n\t<tfoot class=\"dijitReset dijitCalendarYearContainer\">\n\t\t<tr>\n\t\t\t<td class='dijitReset' valign=\"top\" colspan=\"7\">\n\t\t\t\t<h3 class=\"dijitCalendarYearLabel\">\n\t\t\t\t\t<span dojoAttachPoint=\"previousYearLabelNode\" class=\"dijitInline dijitCalendarPreviousYear\"></span>\n\t\t\t\t\t<span dojoAttachPoint=\"currentYearLabelNode\" class=\"dijitInline dijitCalendarSelectedYear\"></span>\n\t\t\t\t\t<span dojoAttachPoint=\"nextYearLabelNode\" class=\"dijitInline dijitCalendarNextYear\"></span>\n\t\t\t\t</h3>\n\t\t\t\t<div class=\"HideElement\" dojoType=\"dijit.form.DropDownButton\" dojoAttachPoint=\"monthDropDownButton\" id=\"${id}_mddb\" tabIndex=\"-1\"></div>\n\t\t\t</td>\n\t\t</tr>\n\t</tfoot>\n</table>\n"},
			'flat'    : {templateString:"<div class=\"Calendar Flat dijitCalendarContainer\"><div class=\"InnerContainer\">\n\t<div>\n\t\t<div class=\"dijitReset dijitCalendarMonthContainer\"><div class=\"MonthSelection\">\n\t\t\t<div class='dijitReset' dojoAttachPoint=\"decrementMonth\">\n\t\t\t\t<span class=\"dijitInline dijitCalendarIncrementControl dijitCalendarDecrease\"><span dojoAttachPoint=\"decreaseArrowNode\" class=\"dijitA11ySideArrow dijitCalendarIncrementControl dijitCalendarDecreaseInner\">-</span></span>\n\t\t\t</div>\n\t\t\t<div class='dijitReset'>\n\t\t\t\t<div dojoAttachPoint=\"monthLabelSpacer\" class=\"dijitCalendarMonthLabelSpacer\"></div>\n\t\t\t\t<div dojoAttachPoint=\"monthLabelNode\" class=\"dijitCalendarMonth\"></div>\n\t\t\t</div>\n\t\t\t<div class='dijitReset' dojoAttachPoint=\"incrementMonth\">\n\t\t\t\t<div class=\"dijitInline dijitCalendarIncrementControl dijitCalendarIncrease\"><span dojoAttachPoint=\"increaseArrowNode\" class=\"dijitA11ySideArrow dijitCalendarIncrementControl dijitCalendarIncreaseInner\">+</span></div>\n\t\t\t</div>\n\t\t</div></div>\n\t\t<div class=\"DayLabelHead\">\n\t\t\t<div class=\"dijitReset dijitCalendarWeekLabelTemplate\"><span class=\"dijitCalendarWeekLabel\"></span></div>\n\t\t\t<div class=\"dijitReset dijitCalendarDayLabelTemplate\"><span class=\"dijitCalendarDayLabel\"></span></div>\n\t\t</div>\n\t</div>\n\t<div dojoAttachEvent=\"onclick: _onDayClick\" class=\"dijitReset dijitCalendarBodyContainer\">\n\t\t<div class=\"dijitReset dijitCalendarWeekTemplate\">\n\t\t\t<div class=\"dijitReset dijitCalendarWeekTemplate\"><span class=\"dijitCalendarWeekLabel\"></span></div>\n\t\t\t<div class=\"dijitReset dijitCalendarDateTemplate\"><span class=\"dijitCalendarDateLabel\"></span></div>\n\t\t</div>\n\t</div>\n\t<div class=\"dijitReset dijitCalendarYearContainer\">\n\t\t<div>\n\t\t\t<div class='dijitReset' >\n\t\t\t\t<h3 class=\"dijitCalendarYearLabel\">\n\t\t\t\t\t<span dojoAttachPoint=\"previousYearLabelNode\" class=\"dijitInline dijitCalendarPreviousYear\"></span>\n\t\t\t\t\t<span dojoAttachPoint=\"currentYearLabelNode\" class=\"dijitInline dijitCalendarSelectedYear\"></span>\n\t\t\t\t\t<span dojoAttachPoint=\"nextYearLabelNode\" class=\"dijitInline dijitCalendarNextYear\"></span>\n\t\t\t\t</h3>\n\t\t\t</div>\n\t\t</div>\n\t</div>\n\t<div class=\"HideElement dijitCalendarMonthLabelTemplate\"></div>\n\t<div class=\"HideElement\" dojoType=\"dijit.form.DropDownButton\" dojoAttachPoint=\"monthDropDownButton\" id=\"${id}_mddb\" tabIndex=\"-1\"></div>\n\t<div class=\"Bottom\"></div>\n</div></div>\n\n"}
		},
		_yearTip: '',

		postMixInProperties: function() {
			this.inherited("postMixInProperties", arguments);
			if (this._templateMapping !== undefined &&  this.templateType !== undefined &&  this._templateDirectory !== undefined) {
				if(this._templateMapping[this.templateType]!==undefined) {
					// check if set to widget's default using its prototype value
					if(this.templateType != this.defaultTemplateType) {
						var tempPath = '';

							// load templates from json object..
							if(typeof this._templateMapping[this.templateType] == 'object'){
								var TempObj = this._templateMapping[this.templateType];

								// ..from shrinksafed packages
								if(TempObj.templateString){
										this.templatePath   = null;
										this.templateString = TempObj.templateString;
								}

								// ..from sources
								else if(TempObj.templatePath){
									var TempTemplateString;
									dojo.xhrGet({
										url: TempObj.templatePath,
										sync: true,
										load: function(data){
											TempTemplateString = data;
										}
									});
									this.templatePath   = null;
									this.templateString = TempTemplateString;
								} else {
										console.warn('Template type: "'+ this.templateType +'" could not be loaded from json object! Use properties templatePath or templateString to declare its template file!');
								}
							}

					}
				} else {
					console.warn('Template type: "'+ this.templateType +'" does not exist in this widget - use default. ('+this.declaredClass+')');
				}
			}
			this._dictionary = new epages.io.Translation(dojo.moduleUrl('epages.widget', "templates/translation"), "auto");
			this._yearTip = this._dictionary.get('YearTip');


		},

		postCreate: function() {
			var d = this.value;
			this.inherited("postCreate", arguments);
			this.attr('value',null);
			this.attr('value',d);

		},

		_populateGrid: function(){
			epages.widget.Calendar.superclass._populateGrid.apply(this);
			dojo.query(".dijitCalendarWeekLabel", this.domNode).forEach(function(label, i) {
				if (i) {
					var node = label.parentNode.nextSibling;
					while (node != null && node.nodeName == '#text'){
						node = node.nextSibling;
					}
					this._setText(label, epages.lang.date.getWeekOfYear(new Date(node.dijitDateValue), dojo.cldr.supplemental.getFirstDayOfWeek(this.lang)));
				}
			}, this);
		},

		_dateNode: function (node) {
			while(node && !node.dijitDateValue){ node = node.parentNode; }
			return node;
		},

		// disallow clicks on calendar weeks
		_onDayClick: function(/*Event*/evt){
			var node = evt.target;
			if(dojo.hasClass(node, "dijitCalendarDateLabel")) {
				epages.widget.Calendar.superclass._onDayClick.apply(this, arguments);
			} else {
				dojo.stopEvent(evt);
			}
		},

		isDisabledDate: function(/*Date*/ date, /*String?*/ locale) {
			date.setHours(0,0,0,0);
			// check if a date is between a the available period
			return (this.lastAvailableDate && date > this.lastAvailableDate) ||
						 (this.firstAvailableDate && date < this.firstAvailableDate);
		},

		_onMenuHover: function(e){
			dojo.stopEvent(e);
			dojo.toggleClass(e.target, "dijitMenuItemHover");
		},

		_onMonthToggle: function(/*Event*/ evt){
			// summary:
			//      Handler for when user triggers or dismisses the month list
			// tags:
			//      protected
			dojo.stopEvent(evt);

			if(evt.type == "mousedown"){
				var coords = dojo.position(this.monthLabelNode);
//				coords.y -= dojo.position(this.domNode, true).y;
				// Size the dropdown's width to match the label in the widget
				// so that they are horizontally aligned
				var dim = {
					width: coords.w + "px",
					top: -this.displayMonth.getMonth() * coords.h + "px"
				};
				if((dojo.isIE && dojo.isQuirks) || dojo.isIE < 7){
					dim.left = -coords.w/2 + "px";
				}
				dojo.style(this.monthDropDown, dim);
				this._popupHandler = this.connect(document, "onmouseup", "_onMonthToggle");
			}else{
				this.disconnect(this._popupHandler);
				delete this._popupHandler;
			}

			dojo.toggleClass(this.monthDropDown, "dijitHidden");
			dojo.toggleClass(this.monthLabelNode, "dijitVisible");
		}
});

}
