﻿/*
Copyright (c) 2003-2013, CKSource - Frederico Knabben. All rights reserved.
For licensing, see LICENSE.html or http://ckeditor.com/license
*/

define("ckeditor/plugins/eptable/plugin", [
	"jquery",
	"ckeditor/ckeditor"
], function ($, CKEDITOR) {

	CKEDITOR.plugins.add( 'eptable',
	{
		requires : [ 'dialog' ],
		init : function( editor )
		{
			var table = CKEDITOR.plugins.eptable,
				lang = editor.lang.table;

			editor.addCommand( 'eptable', new CKEDITOR.dialogCommand( 'eptable' ) );
			editor.addCommand( 'eptableProperties', new CKEDITOR.dialogCommand( 'eptableProperties' ) );

			editor.ui.addButton( 'eptable',
				{
					label : lang.toolbar,
					command : 'eptable',
					icon: this.path + 'images/table.png'
				});

			CKEDITOR.dialog.add( 'eptable', this.path + 'dialogs/table.js' );
			CKEDITOR.dialog.add( 'eptableProperties', this.path + 'dialogs/table.js' );

			// If the "menu" plugin is loaded, register the menu items.
			if ( editor.addMenuItems )
			{

				editor.addMenuItems(
					{
						eptable :
						{
							label : lang.menu,
							command : 'eptableProperties',
							group : 'table',
							order : 5
						}
					} );
			}

			editor.on( 'doubleclick', function( evt )
				{
					var element = evt.data.element;

					if ( element.is( 'table' ) )
						evt.data.dialog = 'eptableProperties';
				});

			// If the "contextmenu" plugin is loaded, register the listeners.
			if ( editor.contextMenu ){

				editor.contextMenu.addListener( function( element, selection ){
					if ( !element || element.isReadOnly() )
						return null;

					var isTable = element.hasAscendant( 'table', 1 );

					if ( isTable )
					{
						return {
							eptable : CKEDITOR.TRISTATE_OFF
						};
					}

					return null;
				});

				// remove default table entry in context menu
				window.setTimeout(function(){
					editor.removeMenuItem('table');
					editor.removeMenuItem('tablecell_properties');
				}, 1);
			}
		}
	});

	return CKEDITOR;
});